NotificationsManager (Social Portal ASL Extension 0.9.1-SNAPSHOT API)
Date: 2014-05-10

org.gcube.applicationsupportlayer.social

## Interface NotificationsManager

- All Known Implementing Classes:
    ApplicationNotificationsManager

      public interface NotificationsManager

  Author:
    Massimiliano Assante, ISTI-CNR

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `notifyAddedItem(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceItem item, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)` use to notify a user he got a workspace item new in some of his workspace shared folder
    `boolean` | `notifyCommentOnFavorite(String userIdToNotify, String feedid, String commentText)` use to notify a user that someone commented on one of his favorite posts
    `boolean` | `notifyCommentReply(String userIdToNotify, String feedid, String feedText, String feedOwnerFullName, String feedOwnerId)` use to notify a user that commented on a post (Not his) that someone commented too
    `boolean` | `notifyDeletedCalendarEvent(String userIdToNotify, String eventTitle, String eventType, Date startDate, Date endingDate)`
    `boolean` | `notifyDocumentWorkflowFirstStepRequest(String userIdToNotify, String documentWorkflowId, String documentName, String assignedRole)` use to notify a document workflow user that a new Document Workflow was created and he is involved in the first step and he is requested to do a task
    `boolean` | `notifyDocumentWorkflowStepForwardComplete(String userIdToNotify, String documentWorkflowId, String documentName, String fromStepName, String toStepName)` use to notify a document workflow owner that someone forwarded and the workflow moved to another step a document worflow he created
    `boolean` | `notifyDocumentWorkflowTaskRequest(String userIdToNotify, String documentWorkflowId, String documentName, String assignedRole)` use to notify a document workflow user (user that in the same document workflow) that he is requested to do a task
    `boolean` | `notifyDocumentWorkflowUpdate(String userIdToNotify, String documentWorkflowId, String documentName)` use to notify a document workflow owner that someone has updated a document involved in a worflow he created
    `boolean` | `notifyDocumentWorkflowUserForward(String userIdToNotify, String documentWorkflowId, String documentName, String fromStepName, String toStepName)` use to notify a document workflow owner that a user performed a forward action to another step a document worflow he created
    `boolean` | `notifyDocumentWorkflowView(String userIdToNotify, String documentWorkflowId, String documentName)` use to notify a document workflow owner that someone has viewed a document involved in a worflow he created
    `boolean` | `notifyEditedCalendarEvent(String userIdToNotify, String eventTitle, String eventType, Date startDate, Date endingDate)`
    `boolean` | `notifyFolderAddedUser(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder, String newAddedUserId)` use to notify a user that a new user was added in on of his workspace shared folder
    `boolean` | `notifyFolderAddedUsers(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder, List<String> newAddedUserIds)` use to notify a user that a new user was added in on of his workspace shared folder
    `boolean` | `notifyFolderRemovedUser(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)` use to notify a user that an existing user was removed from one of his workspace shared folder
    `boolean` | `notifyFolderRenaming(String userIdToNotify, String previousName, String newName, String renamedFolderId)` use to notify a user he got a workspace folder renamed
    `boolean` | `notifyFolderSharing(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)` use to notify a user he got a workspace folder shared
    `boolean` | `notifyItemRenaming(String userIdToNotify, String previousName, org.gcube.common.homelibrary.home.workspace.WorkspaceItem renamedItem)` use to notify a user he got a workspace item renamed
    `boolean` | `notifyJobStatus(String userIdToNotify, org.gcube.portal.databook.shared.ApplicationProfile executingJobApId, org.gcube.portal.databook.shared.RunningJob job)` use to notify a user he got one of his job finished
    `boolean` | `notifyLikedFeed(String userIdToNotify, String feedid, String feedText)` use to notify a user he got one of his post liked
    `boolean` | `notifyMessageReceived(String userIdToNotify, String subject)`
    `boolean` | `notifyMovedItem(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceItem item, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)` use to notify a user he got a workspace item deleted from one of his workspace shared folder
    `boolean` | `notifyNewCalendarEvent(String userIdToNotify, String eventTitle, String eventType, Date startDate, Date endingDate)`
    `boolean` | `notifyOwnCommentReply(String userIdToNotify, String feedid, String feedText)` use to notify a user that someone commented on his post
    `boolean` | `notifyPost(String userIdToNotify, String feedid, String feedText)` use to notify a user that someone created this post
    `boolean` | `notifyRemovedItem(String userIdToNotify, String item, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)` use to notify a user he got a workspace item deleted from one of his workspace shared folder
    `boolean` | `notifyUpdatedItem(String userIdToNotify, org.gcube.common.homelibrary.home.workspace.WorkspaceItem item, org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)` use to notify a user he got a workspace item updated from one of his workspace shared folder
    `boolean` | `notifyUserTag(String userIdToNotify, String feedid, String commentText)` use to notify a user that he was mentioned (tagged) on a post

- - ### Method Detail

    - #### notifyFolderSharing

          boolean notifyFolderSharing(String userIdToNotify,
                                    org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)
                                      throws Exception

      use to notify a user he got a workspace folder shared
      Parameters:
        `userIdToNotify` - the user you want to notify
        `sharedFolder` - the shared `WorkspaceFolder`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyFolderRenaming

          boolean notifyFolderRenaming(String userIdToNotify,
                                     String previousName,
                                     String newName,
                                     String renamedFolderId)
                                       throws Exception

      use to notify a user he got a workspace folder renamed
      Parameters:
        `userIdToNotify` - the user you want to notify
        `previousName` - the previous name of the folder
        `newName` - the new name of the folder
        `renamedFolderId` - the folderId
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyFolderAddedUser

          boolean notifyFolderAddedUser(String userIdToNotify,
                                      org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder,
                                      String newAddedUserId)
                                        throws Exception

      use to notify a user that a new user was added in on of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `sharedFolder` - the shared `WorkspaceFolder`
        `newAddedUserId` - the new user that was added
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyFolderAddedUsers

          boolean notifyFolderAddedUsers(String userIdToNotify,
                                       org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder,
                                       List<String> newAddedUserIds)
                                         throws Exception

      use to notify a user that a new user was added in on of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `sharedFolder` - the shared `WorkspaceFolder`
        `newAddedUserIds` - List of new users that were added
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyFolderRemovedUser

          boolean notifyFolderRemovedUser(String userIdToNotify,
                                        org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)
                                          throws Exception

      use to notify a user that an existing user was removed from one of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `sharedFolder` - the shared `WorkspaceFolder`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyAddedItem

          boolean notifyAddedItem(String userIdToNotify,
                                org.gcube.common.homelibrary.home.workspace.WorkspaceItem item,
                                org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)
                                  throws Exception

      use to notify a user he got a workspace item new in some of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `newItem` - the new shared `WorkspaceItem`
        `sharedFolder` - the shared folder `WorkspaceFolder`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyMovedItem

          boolean notifyMovedItem(String userIdToNotify,
                                org.gcube.common.homelibrary.home.workspace.WorkspaceItem item,
                                org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)
                                  throws Exception

      use to notify a user he got a workspace item deleted from one of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `removedItem` - the removed `WorkspaceItem`
        `sharedFolder` - the shared folder `WorkspaceFolder`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyRemovedItem

          boolean notifyRemovedItem(String userIdToNotify,
                                  String item,
                                  org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)
                                    throws Exception

      use to notify a user he got a workspace item deleted from one of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `removedItem` - the removed `WorkspaceItem`
        `sharedFolder` - the shared folder `WorkspaceFolder`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyUpdatedItem

          boolean notifyUpdatedItem(String userIdToNotify,
                                  org.gcube.common.homelibrary.home.workspace.WorkspaceItem item,
                                  org.gcube.common.homelibrary.home.workspace.WorkspaceFolder sharedFolder)
                                    throws Exception

      use to notify a user he got a workspace item updated from one of his workspace shared folder
      Parameters:
        `userIdToNotify` - the user you want to notify
        `updatedItem` - the updated shared `WorkspaceItem`
        `sharedFolder` - the shared folder `WorkspaceFolder`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyItemRenaming

          boolean notifyItemRenaming(String userIdToNotify,
                                   String previousName,
                                   org.gcube.common.homelibrary.home.workspace.WorkspaceItem renamedItem)
                                     throws Exception

      use to notify a user he got a workspace item renamed
      Parameters:
        `userIdToNotify` - the user you want to notify
        `previousName` - the previous name of the folder
        `renamedItem` - the renamed `WorkspaceItem`
      Returns:
        true if the notification is correctly delivered, false otherwise
      Throws:
        `Exception`

    - #### notifyMessageReceived

          boolean notifyMessageReceived(String userIdToNotify,
                                      String subject)

      Parameters:
        `userIdToNotify` - the user you want to notify
        `subject` - the subject of the message sent
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyNewCalendarEvent

          boolean notifyNewCalendarEvent(String userIdToNotify,
                                       String eventTitle,
                                       String eventType,
                                       Date startDate,
                                       Date endingDate)

      Parameters:
        `userIdToNotify` - the user you want to notify
        `eventTitle` - the title of the event
        `eventType` - the type of the event
        `startDate` - staring date
        `endingDate` - ending date
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyEditedCalendarEvent

          boolean notifyEditedCalendarEvent(String userIdToNotify,
                                          String eventTitle,
                                          String eventType,
                                          Date startDate,
                                          Date endingDate)

      Parameters:
        `userIdToNotify` - the user you want to notify
        `eventTitle` - the title of the event
        `eventType` - the type of the event
        `startDate` - staring date
        `endingDate` - ending date
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDeletedCalendarEvent

          boolean notifyDeletedCalendarEvent(String userIdToNotify,
                                           String eventTitle,
                                           String eventType,
                                           Date startDate,
                                           Date endingDate)

      Parameters:
        `userIdToNotify` - the user you want to notify
        `eventTitle` - the title of the event
        `eventType` - the type of the event
        `startDate` - staring date
        `endingDate` - ending date
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyPost

          boolean notifyPost(String userIdToNotify,
                           String feedid,
                           String feedText)

      use to notify a user that someone created this post
      Parameters:
        `userIdToNotify` - the user you want to notify
        `feedid` - the liked feedid
        `feedText` - the liked feed text or a portion of it
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyOwnCommentReply

          boolean notifyOwnCommentReply(String userIdToNotify,
                                      String feedid,
                                      String feedText)

      use to notify a user that someone commented on his post
      Parameters:
        `userIdToNotify` - the user you want to notify
        `feedid` - the liked feedid
        `feedText` - the liked feed text or a portion of it
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyCommentReply

          boolean notifyCommentReply(String userIdToNotify,
                                   String feedid,
                                   String feedText,
                                   String feedOwnerFullName,
                                   String feedOwnerId)

      use to notify a user that commented on a post (Not his) that someone commented too
      Parameters:
        `userIdToNotify` - the user you want to notify
        `feedid` - the liked feedid
        `feedText` - the liked feed text or a portion of it
        `feedOwnerFullName` - the full name of the user who created this post
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyCommentOnFavorite

          boolean notifyCommentOnFavorite(String userIdToNotify,
                                        String feedid,
                                        String commentText)

      use to notify a user that someone commented on one of his favorite posts
      Parameters:
        `userIdToNotify` - the user you want to notify
        `feedid` - the liked feedid
        `commentText` - the commentText
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyUserTag

          boolean notifyUserTag(String userIdToNotify,
                              String feedid,
                              String commentText)

      use to notify a user that he was mentioned (tagged) on a post
      Parameters:
        `userIdToNotify` - the user you want to notify
        `feedid` - the liked feedid
        `feedText` - the liked feed text or a portion of it
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyLikedFeed

          boolean notifyLikedFeed(String userIdToNotify,
                                String feedid,
                                String feedText)

      use to notify a user he got one of his post liked
      Parameters:
        `userIdToNotify` - the user you want to notify
        `feedid` - the liked feedid
        `feedText` - the liked feed text or a portion of it
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyJobStatus

          boolean notifyJobStatus(String userIdToNotify,
                                org.gcube.portal.databook.shared.ApplicationProfile executingJobApId,
                                org.gcube.portal.databook.shared.RunningJob job)

      use to notify a user he got one of his job finished
      Parameters:
        `userIdToNotify` - the user you want to notify
        `executingApp` - the `ApplicationProfile` of the application from which the job was executed/lauched
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDocumentWorkflowView

          boolean notifyDocumentWorkflowView(String userIdToNotify,
                                           String documentWorkflowId,
                                           String documentName)

      use to notify a document workflow owner that someone has viewed a document involved in a worflow he created
      Parameters:
        `userIdToNotify` - the user you want to notify
        `documentName` - the document title
        `documentid` - the id of the document workflow
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDocumentWorkflowUpdate

          boolean notifyDocumentWorkflowUpdate(String userIdToNotify,
                                             String documentWorkflowId,
                                             String documentName)

      use to notify a document workflow owner that someone has updated a document involved in a worflow he created
      Parameters:
        `userIdToNotify` - the user you want to notify
        `documentName` - the document title
        `documentid` - the id of the document workflow
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDocumentWorkflowTaskRequest

          boolean notifyDocumentWorkflowTaskRequest(String userIdToNotify,
                                                  String documentWorkflowId,
                                                  String documentName,
                                                  String assignedRole)

      use to notify a document workflow user (user that in the same document workflow) that he is requested to do a task
      Parameters:
        `userIdToNotify` - the user you want to notify
        `documentName` - the document title
        `documentid` - the id of the document workflow
        `isStartStep` - set to true is the document worflow was just created
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDocumentWorkflowFirstStepRequest

          boolean notifyDocumentWorkflowFirstStepRequest(String userIdToNotify,
                                                       String documentWorkflowId,
                                                       String documentName,
                                                       String assignedRole)

      use to notify a document workflow user that a new Document Workflow was created and he is involved in the first step and he is requested to do a task
      Parameters:
        `userIdToNotify` - the user you want to notify
        `documentName` - the document title
        `documentid` - the id of the document workflow
        `isStartStep` - set to true is the document worflow was just created
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDocumentWorkflowUserForward

          boolean notifyDocumentWorkflowUserForward(String userIdToNotify,
                                                  String documentWorkflowId,
                                                  String documentName,
                                                  String fromStepName,
                                                  String toStepName)

      use to notify a document workflow owner that a user performed a forward action to another step a document worflow he created
      Parameters:
        `userIdToNotify` - the owner of this document workflow
        `documentWorkflowId` -
        `documentName` -
        `fromStepName` - the name of the step from which the user performed the forward
        `toStepName` - the name of the step to which the user performed the forward
      Returns:
        true if the notification is correctly delivered, false otherwise

    - #### notifyDocumentWorkflowStepForwardComplete

          boolean notifyDocumentWorkflowStepForwardComplete(String userIdToNotify,
                                                          String documentWorkflowId,
                                                          String documentName,
                                                          String fromStepName,
                                                          String toStepName)

      use to notify a document workflow owner that someone forwarded and the workflow moved to another step a document worflow he created
      Parameters:
        `userIdToNotify` - the owner of this document workflow
        `documentWorkflowId` -
        `documentName` -
        `fromStepName` - the name of the step from which the user performed the forward
        `toStepName` - the name of the step to which the user performed the forward
      Returns:
        true if the notification is correctly delivered, false otherwise

Copyright © 2014. All Rights Reserved.